#include "testApp.h"


//--------------------------------------------------------------
void testApp::setup(){	
	
	ofSetVerticalSync(true);
	ofSetFrameRate(60);
	
	
	for (int i = 0; i < 1000; i++){
		particle myParticle;
		float vx = ofRandom(-4,4);
		float vy = ofRandom(-4,4);
		myParticle.setInitialCondition(1000,1000,vx, vy);
		// more interesting with diversity :)
		// uncomment this: 
		if(i%2==0)
		myParticle.damping = ofRandom(0.01, 0.05);
		if(i%3==0)
			myParticle.damping = ofRandom(0.05, 0.09);
	//	if(i%4==0)
	//		myParticle.damping = ofRandom(0.50, 0.15);
	//	if(i%5==0)	
	//	myParticle.damping = ofRandom(1.50, 2.15);
		
		particles.push_back(myParticle);
	}
	
	for (int i = 0; i < 10; i++){
		particle myParticle2;
		float vx = ofRandom(-4,4);
		float vy = ofRandom(-4,4);
		myParticle2.setInitialCondition(1000,1000,vx, vy);
		// more interesting with diversity :)
		// uncomment this: 
		if(i%2==0)
			myParticle2.damping = ofRandom(0.01, 0.05);
		if(i%3==0)
			myParticle2.damping = ofRandom(0.05, 0.09);
		//if(i%4==0)
	//		myParticle2.damping = ofRandom(0.10, 0.15);
		//if(i%5==0)	
		//	myParticle2.damping = ofRandom(1.50, 2.15);
		
		particles2.push_back(myParticle2);
	}
	
}

//--------------------------------------------------------------
void testApp::update(){

	// on every frame 
	// we reset the forces
	// add in any forces on the particle
	// perfom damping and
	// then update
	
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].resetForce();
	
	//	particles[i].addForce(0,0.04);  // gravity
		
	
		particles[i].addDampingForce();
		particles[i].update();
	}
	
	for (int i = 0; i < particles2.size(); i++){
		particles2[i].resetForce();
		
		//particles2[i].addForce(0.04,0);  // gravity
		
		
		particles2[i].addDampingForce();
		particles2[i].update();
	}

}

//--------------------------------------------------------------
void testApp::draw(){
	
	//ofPushMatrix();
	//ofTranslate(particles[i].pos.x, particles[i].pos.y, 0);
	
	//ofTranslate(mouseX, mouseY, 0);
	//ofRotateX(ofGetElapsedTimef()*100); 
	
	//ofCircle(0,0,10);
	//particles[i].draw(3.5f);
	//ofPopMatrix();
	

	ofSetColor(0x000000);
	
	ofPushMatrix();
		ofTranslate(0,0, 0);
		ofRotate(90);
		
	
	
	for (int i = 0; i < particles.size(); i++){
		
	
		ofRotateX(10); 
		
		ofPopMatrix();
		particles[i].draw(3.5f);
		

		for (int j = 0; j < particles2.size(); j++){
	
			ofRotateY(1); 
			
			if(j>25)
			particles2[j].draw(1.3f);
			
			particles2[j].draw(0.7f);
		
		}
		
	}
	
	

	

}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
}

//--------------------------------------------------------------
void testApp::keyReleased  (int key){ 
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	
	for (int i = 0; i < particles.size(); i++){
		float vx = ofRandom(-4,5);
		float vy = ofRandom(-4,5);
		particles[i].setInitialCondition(mouseX,mouseY,vx, vy);	
	
		
		for (int i = 0; i < particles2.size(); i++){
			float vx = ofRandom(-4,5);
			float vy = ofRandom(-4,5);
			particles2[i].setInitialCondition(mouseX,mouseY,vx, vy);	
			
		}
	}
	
	
	

}

//--------------------------------------------------------------
void testApp::mouseReleased(){
}
